Library BDE32INST;

uses
  Windows,
  UnZip,
  RegEdit;

Const
 Path   ='C:\Program Files\BDE32';
 NETDIR ='M:\\APPLI\\DELPHI\\IDAPI';
 VERSION='1';

{$R BDE32.RES}

Function Install:integer; export;
begin
 If ReadRegString(HKEY_LOCAL_MACHINE,'Software\Microsoft\Windows\CurrentVersion\Uninstall\MySoft.BDE','Version','')=VERSION then begin
  Result:=0;
  exit;
 end;
// patch previous versions
 WriteRegString(HKEY_LOCAL_MACHINE,'Software\Microsoft\Windows\CurrentVersion\Uninstall\MySoft.BDE','Version',Version);
 WriteRegString(HKEY_LOCAL_MACHINE,'Software\Microsoft\Windows\CurrentVersion\Uninstall\MySoft.BDE','DisplayName','Borland BDE for Paradox');
 WriteRegString(HKEY_LOCAL_MACHINE,'Software\Microsoft\Windows\CurrentVersion\Uninstall\MySoft.BDE','UninstallString',Path+'\UNINSTALL.EXE');
// no change in BDE files, no need to update them
 If ReadRegString(HKEY_LOCAL_MACHINE,'Software\Borland\BDE32','Version','')=VERSION then begin
  Result:=0;
  exit;
 end;
// UnZIP BDE
 try
  UnZipAllFromResName('BDE32',Path+'\');
 except
  Result:=-1;
  exit;
 end;
// configure BDE
 WriteRegStrings(HKEY_LOCAL_MACHINE,'Software\Borland\Database Engine',[
  'DLLPATH='+Path,
  'CONFIGFILE01='+Path+'\IDAPI32.CFG'
 ]);

 WriteRegStrings(HKEY_LOCAL_MACHINE,'Software\Borland\Database Engine\Settings\DRIVERS\PARADOX\INIT',[
  'NET DIR='+NETDIR,
  'VERSION=3.0',
  'TYPE=FILE',
  'LANGDRIVER=intl'
 ]);

 WriteRegStrings(HKEY_LOCAL_MACHINE,'Software\Borland\Database Engine\Settings\DRIVERS\PARADOX\TABLE CREATE',[
  'LEVEL=4',
  'BLOCK SIZE=2048',
  'FILL FACTOR=95',
  'STRICTINTEGRTY=TRUE'
 ]);

 WriteRegStrings(HKEY_LOCAL_MACHINE,'Software\Borland\BLW32',[
  'BLAPIPATH='+PATH,
  'LOCALE_LIB1='+PATH+'\USA.BLL',
  'LOCALE_LIB2='+PATH+'\EUROPE.BLL'
 ]);

// old version - WriteRegString(HKEY_LOCAL_MACHINE,'Software\Borland\BDE32','Version',VERSION);

 Result:=1;
end;

exports
 Install;

end.
